/*
 *	lab1.cpp
 *
 *	Main program to run ME 161 lab 1
 *		Motor Spin Down Test
 *
 *	-Allison Okamura 9/27/96
 */

/* Includes */
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <iostream.h>
#include <math.h>
#include "ioboard.h"

/* Defines */
#define HI	1
#define LO	0
#define AD_BASE   0x300
#define MAXDATA   5000
#define KV			900 // rpm per volt

/* Global Variables */
float speed[MAXDATA];

/* Functions */

/*----------------------- take_data ------------------------*
 *  Starts taking data from encoder                         *
 *----------------------------------------------------------*/
 void take_data(void)
 {
	int i, data_ctr;
	long int j, k;
	float start_time, end_time, time_inc;
	FILE *fp;
	struct time t;

	// initialize a/d
	init_board();

	// prompt the user
	clrscr();
	printf("Hit any key to quit taking data");

	data_ctr = 0;
	gettime(&t);
	start_time = t.ti_sec + (float)t.ti_hund*0.01;
	//printf("\nstart time = %f\n",start_time);
	while(!kbhit() && (data_ctr<MAXDATA)) {
		// read the A/D
		for (j=0; j<10000L; j++)
			for (k=0; k<10; k++);
		speed[data_ctr] = (float)(read_ad()-2048)*10.0/2048.0*KV; // in rpm
		data_ctr++;
	}
	gettime(&t);
	end_time = t.ti_sec + (float)t.ti_hund*0.01;
	//printf("end time = %f\n",end_time);
	time_inc = (end_time-start_time)/data_ctr;
	//printf("time inc = %f\n",time_inc);
	if (kbhit())  getch();

	// write data file
	printf("\nWriting to data file lab1data.m...\n");
	fp = fopen("lab1data.m", "w");
	fprintf(fp, "% Lab1data.m\n");
	fprintf(fp, "% Run this m-file in Matlab\n");
	fprintf(fp, "%\n% time is in seconds\n% speed is in rpm (revolutions per minute)\n\n");
	for (i=1; i<data_ctr; i++) {
		fprintf(fp, "time(%d) = %f; ", i, time_inc*i);
		if (speed[i]<0) speed[i] = 0;
		fprintf(fp, "speed(%d) = %f;\n ", i, speed[i]);
	}
	fclose(fp);
	printf("\nDone... hit any key to continue");
	while(!kbhit());
   getch();
 }

/*------------------------- menu ---------------------------*
 *  Draws main menu                                         *
 *----------------------------------------------------------*/
void menu(void)
{
	clrscr();
	textcolor(CYAN);
	gotoxy(1,1); cprintf("ME 161 Lab 1 Program");
	textcolor(WHITE);
	gotoxy(1,3); cprintf("When you hit t, the program will start taking data.");
	gotoxy(1,4); cprintf("The data will be stored in a file called lab1data.m");
	gotoxy(1,5); cprintf("After you are done, look at the file to make sure it is okay,");
	gotoxy(1,6); cprintf("then take a copy with you on a floppy for plotting in matlab.");

	gotoxy(1,8); cprintf("Choose one of the following: \n");
	gotoxy(1,9); cprintf("(t)ake data \n");
	gotoxy(1,10); cprintf("(q)uit \n");
	gotoxy(1,12);
}

/*------------------------- main ---------------------------*
 *  Main Loop                                               *
 *----------------------------------------------------------*/
void main(void)
{
	char key;
	int done = LO;

	//init_board();
	menu();

	while (!done) {
		if (kbhit()) {
			key = getch();
			switch(key) {
			case 't':
				take_data();
				menu();
				break;
			case 'q':
				done = HI;
				break;
			default:
				break;
			}
		}
	}

	textcolor(CYAN);
	cprintf("Done.");
}
